#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/smp_lock.h>
#include <linux/grsecurity.h>
#include <linux/grinternal.h>

extern int last_pid;

int
gr_random_pid(spinlock_t * pid_lock, int *next_safe)
{
#ifdef CONFIG_GRKERNSEC_RANDPID
	struct task_struct *p;
	int beginpid, pid;

	if (grsec_enable_randpid && current->fs->root) {
		spin_lock(pid_lock);
		read_lock(&tasklist_lock);

		pid = beginpid = 1 + (get_random_long() % PID_MAX);
repeater:
		for_each_task(p) {
			if (p->pid == pid || p->pgrp == pid ||
			    p->tgid == pid || p->session == pid || last_pid == pid) {
				pid = 1 + (pid % PID_MAX);
				if (unlikely(pid == beginpid)) {
					pid = 0;
					goto done;
				}	
				goto repeater;
			}
		}


		last_pid = pid;
done:
		*next_safe = 0;
		read_unlock(&tasklist_lock);
		spin_unlock(pid_lock);
		return pid;
	}
#endif
	return 0;
}
